Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1795)
@@ -935,881 +315,515 @@
           !                 1,preff,nvertp0(iff))
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          IF (.NOT.clef_stations(iff)) THEN
-             !
-             !IM: there is no way to have one single value in a netcdf file
-             !
-             type_ecri(1) = 'once'
-             type_ecri(2) = 'once'
-             type_ecri(3) = 'once'
-             type_ecri(4) = 'once'
-             type_ecri(5) = 'once'
-             type_ecri(6) = 'once'
-             CALL histdef2d(iff,clef_stations(iff),o_aire%flag,o_aire%name,"Grid area", "-")
-             CALL histdef2d(iff,clef_stations(iff),o_contfracATM%flag,o_contfracATM%name,"% sfce ter+lic", "-")
-          ENDIF
-          type_ecri(:) = type_ecri_files(:)
+    CALL histdef2d(iff,o_aire)
+    CALL histdef2d(iff,o_contfracATM)
 
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          CALL histdef2d(iff,clef_stations(iff),o_phis%flag,o_phis%name,"Surface geop.height", "m2/s2" )
-          CALL histdef2d(iff,clef_stations(iff),o_contfracOR%flag,o_contfracOR%name,"% sfce terre OR", "-" )
-          CALL histdef2d(iff,clef_stations(iff),o_aireTER%flag,o_aireTER%name,"Grid area CONT", "-" )
-          CALL histdef2d(iff,clef_stations(iff),o_flat%flag,o_flat%name, "Latent heat flux", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_slp%flag,o_slp%name, "Sea Level Pressure", "Pa" )
-          CALL histdef2d(iff,clef_stations(iff),o_tsol%flag,o_tsol%name, "Surface Temperature", "K")
-          CALL histdef2d(iff,clef_stations(iff),o_t2m%flag,o_t2m%name, "Temperature 2m", "K" )
-          IF (.NOT.clef_stations(iff)) THEN 
-             !
-             !IM: there is no way to have one single value in a netcdf file
-             !
-             type_ecri(1) = 't_min(X)'
-             type_ecri(2) = 't_min(X)'
-             type_ecri(3) = 't_min(X)'
-             type_ecri(4) = 't_min(X)'
-             type_ecri(5) = 't_min(X)' 
-             type_ecri(6) = 't_min(X)' 
-             CALL histdef2d(iff,clef_stations(iff),o_t2m_min%flag,o_t2m_min%name, "Temp 2m min", "K" )
-             type_ecri(1) = 't_max(X)'
-             type_ecri(2) = 't_max(X)'
-             type_ecri(3) = 't_max(X)'
-             type_ecri(4) = 't_max(X)'
-             type_ecri(5) = 't_max(X)' 
-             type_ecri(6) = 't_max(X)' 
-             CALL histdef2d(iff,clef_stations(iff),o_t2m_max%flag,o_t2m_max%name, "Temp 2m max", "K" )
-          ENDIF
-          type_ecri(:) = type_ecri_files(:)
-          CALL histdef2d(iff,clef_stations(iff),o_wind10m%flag,o_wind10m%name, "10-m wind speed", "m/s")
-          CALL histdef2d(iff,clef_stations(iff),o_wind10max%flag,o_wind10max%name, "10m wind speed max", "m/s")
-          CALL histdef2d(iff,clef_stations(iff),o_sicf%flag,o_sicf%name, "Sea-ice fraction", "-" )
-          CALL histdef2d(iff,clef_stations(iff),o_q2m%flag,o_q2m%name, "Specific humidity 2m", "kg/kg")
-          CALL histdef2d(iff,clef_stations(iff),o_ustar%flag,o_ustar%name, "Friction velocity", "m/s" )
-          CALL histdef2d(iff,clef_stations(iff),o_u10m%flag,o_u10m%name, "Vent zonal 10m", "m/s" )
-          CALL histdef2d(iff,clef_stations(iff),o_v10m%flag,o_v10m%name, "Vent meridien 10m", "m/s")
-          CALL histdef2d(iff,clef_stations(iff),o_psol%flag,o_psol%name, "Surface Pressure", "Pa" ) 
-          CALL histdef2d(iff,clef_stations(iff),o_qsurf%flag,o_qsurf%name, "Surface Air humidity", "kg/kg")
-
-          if (.not. ok_veget) then
-             CALL histdef2d(iff,clef_stations(iff),o_qsol%flag,o_qsol%name, "Soil watter content", "mm" )
-          endif
-
-             type_ecri(1) = 'inst(X)'
-             type_ecri(2) = 'inst(X)'
-             type_ecri(3) = 'inst(X)'
-             type_ecri(4) = 'inst(X)'
-             type_ecri(5) = 'inst(X)'
-             type_ecri(6) = 'inst(X)'
-          CALL histdef2d(iff,clef_stations(iff),o_ndayrain%flag,o_ndayrain%name, "Number of dayrain(liq+sol)", "-")
-             type_ecri(:) = type_ecri_files(:)
-          CALL histdef2d(iff,clef_stations(iff),o_precip%flag,o_precip%name, "Precip Totale liq+sol", "kg/(s*m2)" )
-          CALL histdef2d(iff,clef_stations(iff),o_plul%flag,o_plul%name, "Large-scale Precip.", "kg/(s*m2)") 
-          CALL histdef2d(iff,clef_stations(iff),o_pluc%flag,o_pluc%name, "Convective Precip.", "kg/(s*m2)")
-          CALL histdef2d(iff,clef_stations(iff),o_snow%flag,o_snow%name, "Snow fall", "kg/(s*m2)" )
-          CALL histdef2d(iff,clef_stations(iff),o_msnow%flag,o_msnow%name, "Surface snow amount", "kg/m2" )
-          CALL histdef2d(iff,clef_stations(iff),o_fsnow%flag,o_fsnow%name, "Surface snow area fraction", "-" )
-          CALL histdef2d(iff,clef_stations(iff),o_evap%flag,o_evap%name, "Evaporat", "kg/(s*m2)" ) 
-          CALL histdef2d(iff,clef_stations(iff),o_tops%flag,o_tops%name, "Solar rad. at TOA", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_tops0%flag,o_tops0%name, "CS Solar rad. at TOA", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_topl%flag,o_topl%name, "IR rad. at TOA", "W/m2" )
-          CALL histdef2d(iff,clef_stations(iff),o_topl0%flag,o_topl0%name, "IR rad. at TOA", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWupTOA%flag,o_SWupTOA%name, "SWup at TOA", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_SWupTOAclr%flag,o_SWupTOAclr%name, "SWup clear sky at TOA", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWdnTOA%flag,o_SWdnTOA%name, "SWdn at TOA", "W/m2" )
-          CALL histdef2d(iff,clef_stations(iff),o_SWdnTOAclr%flag,o_SWdnTOAclr%name, "SWdn clear sky at TOA", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_nettop%flag,o_nettop%name, "Net dn radiatif flux at TOA", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWup200%flag,o_SWup200%name, "SWup at 200mb", "W/m2" ) 
-          CALL histdef2d(iff,clef_stations(iff),o_SWup200clr%flag,o_SWup200clr%name, "SWup clear sky at 200mb", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWdn200%flag,o_SWdn200%name, "SWdn at 200mb", "W/m2" )
-          CALL histdef2d(iff,clef_stations(iff),o_SWdn200clr%flag,o_SWdn200clr%name, "SWdn clear sky at 200mb", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWup200%flag,o_LWup200%name, "LWup at 200mb", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_LWup200clr%flag,o_LWup200clr%name, "LWup clear sky at 200mb", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWdn200%flag,o_LWdn200%name, "LWdn at 200mb", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_LWdn200clr%flag,o_LWdn200clr%name, "LWdn clear sky at 200mb", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_sols%flag,o_sols%name, "Solar rad. at surf.", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_sols0%flag,o_sols0%name, "Solar rad. at surf.", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_soll%flag,o_soll%name, "IR rad. at surface", "W/m2")  
-          CALL histdef2d(iff,clef_stations(iff),o_radsol%flag,o_radsol%name, "Rayonnement au sol", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_soll0%flag,o_soll0%name, "IR rad. at surface", "W/m2") 
-          CALL histdef2d(iff,clef_stations(iff),o_SWupSFC%flag,o_SWupSFC%name, "SWup at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWupSFCclr%flag,o_SWupSFCclr%name, "SWup clear sky at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWdnSFC%flag,o_SWdnSFC%name, "SWdn at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWdnSFCclr%flag,o_SWdnSFCclr%name, "SWdn clear sky at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWupSFC%flag,o_LWupSFC%name, "Upwd. IR rad. at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWdnSFC%flag,o_LWdnSFC%name, "Down. IR rad. at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWupSFCclr%flag,o_LWupSFCclr%name, "CS Upwd. IR rad. at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWdnSFCclr%flag,o_LWdnSFCclr%name, "Down. CS IR rad. at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_bils%flag,o_bils%name, "Surf. total heat flux", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_sens%flag,o_sens%name, "Sensible heat flux", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_fder%flag,o_fder%name, "Heat flux derivation", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_ffonte%flag,o_ffonte%name, "Thermal flux for snow melting", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_fqcalving%flag,o_fqcalving%name, "Ice Calving", "kg/m2/s") 
-          CALL histdef2d(iff,clef_stations(iff),o_fqfonte%flag,o_fqfonte%name, "Land ice melt", "kg/m2/s") 
-
-          CALL histdef2d(iff,clef_stations(iff),o_taux%flag,o_taux%name, "Zonal wind stress","Pa")
-          CALL histdef2d(iff,clef_stations(iff),o_tauy%flag,o_tauy%name, "Meridional wind stress","Pa")
-
-          DO nsrf = 1, nbsrf
-             CALL histdef2d(iff,clef_stations(iff),o_pourc_srf(nsrf)%flag,o_pourc_srf(nsrf)%name,"% "//clnsurf(nsrf),"%")
-             CALL histdef2d(iff,clef_stations(iff),o_fract_srf(nsrf)%flag,o_fract_srf(nsrf)%name,"Fraction "//clnsurf(nsrf),"1")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_taux_srf(nsrf)%flag,o_taux_srf(nsrf)%name,"Zonal wind stress"//clnsurf(nsrf),"Pa")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_tauy_srf(nsrf)%flag,o_tauy_srf(nsrf)%name,"Meridional wind stress "//clnsurf(nsrf),"Pa")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_tsol_srf(nsrf)%flag,o_tsol_srf(nsrf)%name,"Temperature "//clnsurf(nsrf),"K")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_evappot_srf(nsrf)%flag,o_evappot_srf(nsrf)%name,"Temperature"//clnsurf(nsrf),"K")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_ustar_srf(nsrf)%flag,o_ustar_srf(nsrf)%name,"Friction velocity "//clnsurf(nsrf),"m/s")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_u10m_srf(nsrf)%flag,o_u10m_srf(nsrf)%name,"Vent Zonal 10m "//clnsurf(nsrf),"m/s")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_evap_srf(nsrf)%flag,o_evap_srf(nsrf)%name,"evaporation at surface "//clnsurf(nsrf),"kg/(s*m2)")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_v10m_srf(nsrf)%flag,o_v10m_srf(nsrf)%name,"Vent meredien 10m "//clnsurf(nsrf),"m/s")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_t2m_srf(nsrf)%flag,o_t2m_srf(nsrf)%name,"Temp 2m "//clnsurf(nsrf),"K")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_sens_srf(nsrf)%flag,o_sens_srf(nsrf)%name,"Sensible heat flux "//clnsurf(nsrf),"W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_lat_srf(nsrf)%flag,o_lat_srf(nsrf)%name,"Latent heat flux "//clnsurf(nsrf),"W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_flw_srf(nsrf)%flag,o_flw_srf(nsrf)%name,"LW "//clnsurf(nsrf),"W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_fsw_srf(nsrf)%flag,o_fsw_srf(nsrf)%name,"SW "//clnsurf(nsrf),"W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_wbils_srf(nsrf)%flag,o_wbils_srf(nsrf)%name,"Bilan sol "//clnsurf(nsrf),"W/m2" )
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_wbilo_srf(nsrf)%flag,o_wbilo_srf(nsrf)%name,"Bilan eau "//clnsurf(nsrf),"kg/(m2*s)")
-             if (iflag_pbl>1 .and. lev_files(iff).gt.10 ) then
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_tke_srf(nsrf)%flag,o_tke_srf(nsrf)%name,"Max Turb. Kinetic Energy "//clnsurf(nsrf),"-")
-
-                IF (.NOT.clef_stations(iff)) THEN 
-                   !
-                   !IM: there is no way to have one single value in a netcdf file
-                   !
-                   type_ecri(1) = 't_max(X)'
-                   type_ecri(2) = 't_max(X)'
-                   type_ecri(3) = 't_max(X)'
-                   type_ecri(4) = 't_max(X)'
-                   type_ecri(5) = 't_max(X)'
-                   type_ecri(6) = 't_max(X)'
-                   CALL histdef2d(iff,clef_stations(iff), &
-                        o_tke_max_srf(nsrf)%flag,o_tke_max_srf(nsrf)%name,"Max Turb. Kinetic Energy "//clnsurf(nsrf),"-")
-                   type_ecri(:) = type_ecri_files(:)
-                ENDIF
-
-             endif
-
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_albe_srf(nsrf)%flag,o_albe_srf(nsrf)%name,"Albedo VIS surf. "//clnsurf(nsrf),"-")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_rugs_srf(nsrf)%flag,o_rugs_srf(nsrf)%name,"Surface roughness "//clnsurf(nsrf),"m")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_ages_srf(nsrf)%flag,o_ages_srf(nsrf)%name,"Snow age", "day")
-          END DO
-
-          IF (new_aod .AND. (.NOT. aerosol_couple)) THEN
-             IF (ok_ade.OR.ok_aie) THEN
-
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_od550aer%flag,o_od550aer%name, "Total aerosol optical depth at 550nm", "-")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_od865aer%flag,o_od865aer%name, "Total aerosol optical depth at 870nm", "-")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_absvisaer%flag,o_absvisaer%name, "Absorption aerosol visible optical depth", "-")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_od550lt1aer%flag,o_od550lt1aer%name, "Fine mode optical depth", "-")
-
-
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_sconcso4%flag,o_sconcso4%name,"Surface Concentration of Sulfate ","kg/m3")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_sconcoa%flag,o_sconcoa%name,"Surface Concentration of Organic Aerosol ","kg/m3")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_sconcbc%flag,o_sconcbc%name,"Surface Concentration of Black Carbon ","kg/m3")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_sconcss%flag,o_sconcss%name,"Surface Concentration of Sea Salt ","kg/m3")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_sconcdust%flag,o_sconcdust%name,"Surface Concentration of Dust ","kg/m3")
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_concso4%flag,o_concso4%name,"Concentration of Sulfate ","kg/m3")
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_concoa%flag,o_concoa%name,"Concentration of Organic Aerosol ","kg/m3")
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_concbc%flag,o_concbc%name,"Concentration of Black Carbon ","kg/m3")
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_concss%flag,o_concss%name,"Concentration of Sea Salt ","kg/m3")
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_concdust%flag,o_concdust%name,"Concentration of Dust ","kg/m3")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_loadso4%flag,o_loadso4%name,"Column Load of Sulfate ","kg/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_loadoa%flag,o_loadoa%name,"Column Load of Organic Aerosol ","kg/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_loadbc%flag,o_loadbc%name,"Column Load of Black Carbon ","kg/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_loadss%flag,o_loadss%name,"Column Load of Sea Salt ","kg/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_loaddust%flag,o_loaddust%name,"Column Load of Dust ","kg/m2")
-
-                DO naero = 1, naero_spc
-                   CALL histdef2d(iff,clef_stations(iff), &
-                        o_tausumaero(naero)%flag,o_tausumaero(naero)%name,"Aerosol Optical depth at 550 nm "//name_aero(naero),"1")
-                END DO
-             ENDIF
-          ENDIF
-
-          IF (ok_ade) THEN
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_topswad%flag,o_topswad%name, "ADE at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_topswad0%flag,o_topswad0%name, "ADE clear-sky at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_solswad%flag,o_solswad%name, "ADE at SRF", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_solswad0%flag,o_solswad0%name, "ADE clear-sky at SRF", "W/m2")
-
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swtoaas_nat%flag,o_swtoaas_nat%name, "Natural aerosol radiative forcing all-sky at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swsrfas_nat%flag,o_swsrfas_nat%name, "Natural aerosol radiative forcing all-sky at SRF", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swtoacs_nat%flag,o_swtoacs_nat%name, "Natural aerosol radiative forcing clear-sky at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swsrfcs_nat%flag,o_swsrfcs_nat%name, "Natural aerosol radiative forcing clear-sky at SRF", "W/m2")
-
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swtoaas_ant%flag,o_swtoaas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swsrfas_ant%flag,o_swsrfas_ant%name, "Anthropogenic aerosol radiative forcing all-sky at SRF", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swtoacs_ant%flag,o_swtoacs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_swsrfcs_ant%flag,o_swsrfcs_ant%name, "Anthropogenic aerosol radiative forcing clear-sky at SRF", "W/m2")
-
-             IF (.NOT. aerosol_couple) THEN 
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_swtoacf_nat%flag,o_swtoacf_nat%name, "Natural aerosol impact on cloud radiative forcing at TOA", "W/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_swsrfcf_nat%flag,o_swsrfcf_nat%name, "Natural aerosol impact on cloud radiative forcing  at SRF", "W/m2")
-                CALL histdef2d(iff, clef_stations(iff), o_swtoacf_ant%flag, &
-                     o_swtoacf_ant%name, &
-                     "Anthropogenic aerosol impact on cloud radiative forcing at TOA", &
-                     "W/m2")
-                CALL histdef2d(iff, clef_stations(iff), o_swsrfcf_ant%flag, &
-                     o_swsrfcf_ant%name, &
-                     "Anthropogenic aerosol impact on cloud radiative forcing at SRF", &
-                     "W/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_swtoacf_zero%flag,o_swtoacf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at TOA", "W/m2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_swsrfcf_zero%flag,o_swsrfcf_zero%name, "Cloud radiative forcing (allsky-clearsky fluxes) at SRF", "W/m2")
-             ENDIF
-          ENDIF
-
-          IF (ok_aie) THEN
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_topswai%flag,o_topswai%name, "AIE at TOA", "W/m2")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_solswai%flag,o_solswai%name, "AIE at SFR", "W/m2")
-             !Cloud droplet number concentration
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_scdnc%flag,o_scdnc%name, "Cloud droplet number concentration","m-3")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_cldncl%flag,o_cldncl%name, "CDNC at top of liquid water cloud", "m-3")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_reffclws%flag,o_reffclws%name, "Stratiform Cloud Droplet Effective Radius (aerosol diags.)","m")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_reffclwc%flag,o_reffclwc%name, "Convective Cloud Droplet Effective Radius (aerosol diags.)","m")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_cldnvi%flag,o_cldnvi%name, "Column Integrated Cloud Droplet Number", "m-2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_lcc3d%flag,o_lcc3d%name, "Cloud liquid fraction","1")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_lcc3dcon%flag,o_lcc3dcon%name, "Convective cloud liquid fraction","1")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_lcc3dstra%flag,o_lcc3dstra%name, "Stratiform cloud liquid fraction","1")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_lcc%flag,o_lcc%name, "Cloud liquid fraction at top of cloud","1")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_reffclwtop%flag,o_reffclwtop%name, "Droplet effective radius at top of liquid water cloud", "m")
-          ENDIF
-
-
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_alb1%flag,o_alb1%name, "Surface VIS albedo", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_alb2%flag,o_alb2%name, "Surface Near IR albedo", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cdrm%flag,o_cdrm%name, "Momentum drag coef.", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cdrh%flag,o_cdrh%name, "Heat drag coef.", "-" )
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cldl%flag,o_cldl%name, "Low-level cloudiness", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cldm%flag,o_cldm%name, "Mid-level cloudiness", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cldh%flag,o_cldh%name, "High-level cloudiness", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cldt%flag,o_cldt%name, "Total cloudiness", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_cldq%flag,o_cldq%name, "Cloud liquid water path", "kg/m2")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_lwp%flag,o_lwp%name, "Cloud water path", "kg/m2")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_iwp%flag,o_iwp%name, "Cloud ice water path", "kg/m2" )
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_ue%flag,o_ue%name, "Zonal energy transport", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_ve%flag,o_ve%name, "Merid energy transport", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_uq%flag,o_uq%name, "Zonal humidity transport", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_vq%flag,o_vq%name, "Merid humidity transport", "-")
-
-          IF(iflag_con.GE.3) THEN ! sb
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_cape%flag,o_cape%name, "Conv avlbl pot ener", "J/kg")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_pbase%flag,o_pbase%name, "Cld base pressure", "Pa")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_ptop%flag,o_ptop%name, "Cld top pressure", "Pa")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_fbase%flag,o_fbase%name, "Cld base mass flux", "kg/m2/s")
-             if (iflag_con /= 30) then
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_plcl%flag,o_plcl%name, "Lifting Condensation Level", "hPa")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_plfc%flag,o_plfc%name, "Level of Free Convection", "hPa")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_wbeff%flag,o_wbeff%name, "Conv. updraft velocity at LFC (<100)", "m/s")
-             end if
-             IF (.NOT.clef_stations(iff)) THEN 
-                !
-                !IM: there is no way to have one single value in a netcdf file
-                !
-                type_ecri(1) = 't_max(X)'
-                type_ecri(2) = 't_max(X)'
-                type_ecri(3) = 't_max(X)'
-                type_ecri(4) = 't_max(X)'
-                type_ecri(5) = 't_max(X)'
-                type_ecri(6) = 't_max(X)'
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_cape_max%flag,o_cape_max%name, "CAPE max.", "J/kg")
-             ENDIF
-             type_ecri(:) = type_ecri_files(:)
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_upwd%flag,o_upwd%name, "saturated updraft", "kg/m2/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_Ma%flag,o_Ma%name, "undilute adiab updraft", "kg/m2/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dnwd%flag,o_dnwd%name, "saturated downdraft", "kg/m2/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dnwd0%flag,o_dnwd0%name, "unsat. downdraft", "kg/m2/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_mc%flag,o_mc%name, "Convective mass flux", "kg/m2/s")
-             type_ecri(1) = 'inst(X)'
-             type_ecri(2) = 'inst(X)'
-             type_ecri(3) = 'inst(X)'
-             type_ecri(4) = 'inst(X)'
-             type_ecri(5) = 'inst(X)'
-             type_ecri(6) = 'inst(X)'
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_ftime_con%flag,o_ftime_con%name, "Fraction of time convection Occurs", " ")
-             type_ecri(:) = type_ecri_files(:)
-          ENDIF !iflag_con .GE. 3
-
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_prw%flag,o_prw%name, "Precipitable water", "kg/m2")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_s_pblh%flag,o_s_pblh%name, "Boundary Layer Height", "m")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_s_pblt%flag,o_s_pblt%name, "t at Boundary Layer Height", "K")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_s_lcl%flag,o_s_lcl%name, "Condensation level", "m")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_s_therm%flag,o_s_therm%name, "Exces du thermique", "K")
+    CALL histdef2d(iff,o_phis)
+    CALL histdef2d(iff,o_contfracOR)
+    CALL histdef2d(iff,o_aireTER)
+    CALL histdef2d(iff,o_flat)
+    CALL histdef2d(iff,o_slp)
+    CALL histdef2d(iff,o_tsol)
+    CALL histdef2d(iff,o_t2m)
+    CALL histdef2d(iff,o_t2m_min)
+    CALL histdef2d(iff,o_t2m_max)
+    CALL histdef2d(iff,o_wind10m)
+    CALL histdef2d(iff,o_wind10max)
+    CALL histdef2d(iff,o_sicf)
+    CALL histdef2d(iff,o_q2m)
+    CALL histdef2d(iff,o_ustar)
+    CALL histdef2d(iff,o_u10m)
+    CALL histdef2d(iff,o_v10m)
+    CALL histdef2d(iff,o_psol)
+    CALL histdef2d(iff,o_qsurf)
+
+    IF (.NOT. ok_veget) THEN
+      CALL histdef2d(iff,o_qsol)
+    ENDIF
+    CALL histdef2d(iff,o_ndayrain)
+    CALL histdef2d(iff,o_precip)
+    CALL histdef2d(iff,o_plul)
+    CALL histdef2d(iff,o_pluc)
+    CALL histdef2d(iff,o_snow)
+    CALL histdef2d(iff,o_msnow)
+    CALL histdef2d(iff,o_fsnow)
+    CALL histdef2d(iff,o_evap)
+    CALL histdef2d(iff,o_tops)
+    CALL histdef2d(iff,o_tops0)
+    CALL histdef2d(iff,o_topl)
+    CALL histdef2d(iff,o_topl0)
+    CALL histdef2d(iff,o_SWupTOA)
+    CALL histdef2d(iff,o_SWupTOAclr)
+    CALL histdef2d(iff,o_SWdnTOA)
+    CALL histdef2d(iff,o_SWdnTOAclr)
+    CALL histdef2d(iff,o_nettop)
+    CALL histdef2d(iff,o_SWup200)
+    CALL histdef2d(iff,o_SWup200clr)
+    CALL histdef2d(iff,o_SWdn200)
+    CALL histdef2d(iff,o_SWdn200clr)
+    CALL histdef2d(iff,o_LWup200)
+    CALL histdef2d(iff,o_LWup200clr)
+    CALL histdef2d(iff,o_LWdn200)
+    CALL histdef2d(iff,o_LWdn200clr)
+    CALL histdef2d(iff,o_sols)
+    CALL histdef2d(iff,o_sols0)
+    CALL histdef2d(iff,o_soll)
+    CALL histdef2d(iff,o_radsol)
+    CALL histdef2d(iff,o_soll0)
+    CALL histdef2d(iff,o_SWupSFC)
+    CALL histdef2d(iff,o_SWupSFCclr)
+    CALL histdef2d(iff,o_SWdnSFC)
+    CALL histdef2d(iff,o_SWdnSFCclr)
+    CALL histdef2d(iff,o_LWupSFC)
+    CALL histdef2d(iff,o_LWdnSFC)
+    CALL histdef2d(iff,o_LWupSFCclr)
+    CALL histdef2d(iff,o_LWdnSFCclr)
+    CALL histdef2d(iff,o_bils)
+    CALL histdef2d(iff,o_bils_ec)
+    CALL histdef2d(iff,o_bils_tke)
+    CALL histdef2d(iff,o_bils_diss)
+    CALL histdef2d(iff,o_bils_kinetic)
+    CALL histdef2d(iff,o_bils_enthalp)
+    CALL histdef2d(iff,o_bils_latent)
+    CALL histdef2d(iff,o_sens)
+    CALL histdef2d(iff,o_fder)
+    CALL histdef2d(iff,o_ffonte)
+    CALL histdef2d(iff,o_fqcalving)
+    CALL histdef2d(iff,o_fqfonte)
+    CALL histdef2d(iff,o_taux)
+    CALL histdef2d(iff,o_tauy)
+
+    DO nsrf = 1, nbsrf
+      CALL histdef2d(iff,o_pourc_srf(nsrf))
+      CALL histdef2d(iff,o_fract_srf(nsrf))
+      CALL histdef2d(iff, o_taux_srf(nsrf))
+      CALL histdef2d(iff, o_tauy_srf(nsrf))
+      CALL histdef2d(iff, o_tsol_srf(nsrf))
+      CALL histdef2d(iff, o_evappot_srf(nsrf))
+      CALL histdef2d(iff, o_ustar_srf(nsrf))
+      CALL histdef2d(iff, o_u10m_srf(nsrf))
+      CALL histdef2d(iff, o_evap_srf(nsrf))
+      CALL histdef2d(iff, o_v10m_srf(nsrf))
+      CALL histdef2d(iff, o_t2m_srf(nsrf))
+      CALL histdef2d(iff, o_sens_srf(nsrf))
+      CALL histdef2d(iff, o_lat_srf(nsrf))
+      CALL histdef2d(iff, o_flw_srf(nsrf))
+      CALL histdef2d(iff, o_fsw_srf(nsrf))
+      CALL histdef2d(iff, o_wbils_srf(nsrf))
+      CALL histdef2d(iff, o_wbilo_srf(nsrf))
+      IF (iflag_pbl>1 ) then
+            CALL histdef2d(iff, o_tke_srf(nsrf))
+            CALL histdef2d(iff, o_tke_max_srf(nsrf))
+      ENDIF
+
+      CALL histdef2d(iff, o_albe_srf(nsrf))
+      CALL histdef2d(iff, o_rugs_srf(nsrf))
+      CALL histdef2d(iff, o_ages_srf(nsrf))
+    END DO
+
+    IF (new_aod .AND. (.NOT. aerosol_couple)) THEN
+      IF (ok_ade.OR.ok_aie) THEN
+          CALL histdef2d(iff,o_od550aer)
+          CALL histdef2d(iff,o_od865aer)
+          CALL histdef2d(iff,o_absvisaer)
+          CALL histdef2d(iff,o_od550lt1aer)
+          CALL histdef2d(iff,o_sconcso4)
+          CALL histdef2d(iff,o_sconcoa)
+          CALL histdef2d(iff,o_sconcbc)
+          CALL histdef2d(iff,o_sconcss)
+          CALL histdef2d(iff,o_sconcdust)
+          CALL histdef3d(iff,o_concso4)
+          CALL histdef3d(iff,o_concoa)
+          CALL histdef3d(iff,o_concbc)
+          CALL histdef3d(iff,o_concss)
+          CALL histdef3d(iff,o_concdust)
+          CALL histdef2d(iff,o_loadso4)
+          CALL histdef2d(iff,o_loadoa)
+          CALL histdef2d(iff,o_loadbc)
+          CALL histdef2d(iff,o_loadss)
+          CALL histdef2d(iff,o_loaddust)
+!--STRAT AER
+      ENDIF
+      IF (ok_ade.OR.ok_aie.OR.flag_aerosol_strat) THEN
+        DO naero = 1, naero_spc
+          CALL histdef2d(iff, o_tausumaero(naero))
+        END DO
+      ENDIF
+    ENDIF
+
+    IF (ok_ade) THEN
+      CALL histdef2d(iff,o_topswad)
+      CALL histdef2d(iff,o_topswad0)
+      CALL histdef2d(iff,o_solswad)
+      CALL histdef2d(iff,o_solswad0)
+      CALL histdef2d(iff,o_swtoaas_nat)
+      CALL histdef2d(iff,o_swsrfas_nat)
+      CALL histdef2d(iff,o_swtoacs_nat)
+      CALL histdef2d(iff,o_swsrfcs_nat)
+      CALL histdef2d(iff,o_swtoaas_ant)
+      CALL histdef2d(iff,o_swsrfas_ant)
+      CALL histdef2d(iff,o_swtoacs_ant)
+      CALL histdef2d(iff,o_swsrfcs_ant)
+
+      IF (.NOT. aerosol_couple) THEN 
+            CALL histdef2d(iff,o_swtoacf_nat)
+            CALL histdef2d(iff,o_swsrfcf_nat)
+            CALL histdef2d(iff,o_swtoacf_ant)
+            CALL histdef2d(iff,o_swsrfcf_ant)
+            CALL histdef2d(iff,o_swtoacf_zero)
+            CALL histdef2d(iff,o_swsrfcf_zero)
+      ENDIF
+    ENDIF
+
+    IF (ok_aie) THEN
+      CALL histdef2d(iff,o_topswai)
+      CALL histdef2d(iff,o_solswai)
+                  !Cloud droplet number concentration
+      CALL histdef3d(iff,o_scdnc)
+      CALL histdef2d(iff,o_cldncl)
+      CALL histdef3d(iff,o_reffclws)
+      CALL histdef3d(iff,o_reffclwc)
+      CALL histdef2d(iff,o_cldnvi)
+      CALL histdef3d(iff,o_lcc3d)
+      CALL histdef3d(iff,o_lcc3dcon)
+      CALL histdef3d(iff,o_lcc3dstra)
+      CALL histdef2d(iff,o_lcc)
+      CALL histdef2d(iff,o_reffclwtop)
+    ENDIF
+    CALL histdef2d(iff,o_alb1)
+    CALL histdef2d(iff,o_alb2)
+    CALL histdef2d(iff,o_cdrm)
+    CALL histdef2d(iff,o_cdrh)
+    CALL histdef2d(iff,o_cldl)
+    CALL histdef2d(iff,o_cldm)
+    CALL histdef2d(iff,o_cldh)
+    CALL histdef2d(iff,o_cldt)
+    CALL histdef2d(iff,o_cldq)
+    CALL histdef2d(iff,o_lwp)
+    CALL histdef2d(iff,o_iwp)
+    CALL histdef2d(iff,o_ue)
+    CALL histdef2d(iff,o_ve)
+    CALL histdef2d(iff,o_uq)
+    CALL histdef2d(iff,o_vq)
+
+    IF(iflag_con.GE.3) THEN ! sb
+      CALL histdef2d(iff,o_cape)
+      CALL histdef2d(iff,o_pbase)
+      CALL histdef2d(iff,o_ptop)
+      CALL histdef2d(iff,o_fbase)
+      IF (iflag_con /= 30) THEN
+            CALL histdef2d(iff,o_plcl)
+            CALL histdef2d(iff,o_plfc)
+            CALL histdef2d(iff,o_wbeff)
+      ENDIF
+      CALL histdef2d(iff,o_cape_max)
+      CALL histdef3d(iff,o_upwd)
+      CALL histdef3d(iff,o_Ma)
+      CALL histdef3d(iff,o_dnwd)
+      CALL histdef3d(iff,o_dnwd0)
+      CALL histdef3d(iff,o_mc)
+      CALL histdef2d(iff,o_ftime_con)
+    ENDIF !iflag_con .GE. 3
+    CALL histdef2d(iff,o_prw)
+    CALL histdef2d(iff,o_s_pblh)
+    CALL histdef2d(iff,o_s_pblt)
+    CALL histdef2d(iff,o_s_lcl)
+    CALL histdef2d(iff,o_s_therm)
           !IM : Les champs suivants (s_oliqCL, s_cteiCL, s_trmb1, s_trmb2, s_trmb3) ne sont pas definis dans HBTM.F
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_capCL%flag,o_s_capCL%name, "Conv avlbl pot enerfor ABL", "J/m2" )
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_oliqCL%flag,o_s_oliqCL%name, "Liq Water in BL", "kg/m2")
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_cteiCL%flag,o_s_cteiCL%name, "Instability criteria(ABL)", "K")
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_trmb1%flag,o_s_trmb1%name, "deep_cape(HBTM2)", "J/m2")
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_trmb2%flag,o_s_trmb2%name, "inhibition (HBTM2)", "J/m2")
-          !CALL histdef2d(iff,clef_stations(iff), &
+          !CALL histdef2d(iff, &
           !o_s_trmb3%flag,o_s_trmb3%name, "Point Omega (HBTM2)", "m")
 
           ! Champs interpolles sur des niveaux de pression
 
-          type_ecri(1) = 'inst(X)'
-          type_ecri(2) = 'inst(X)'
-          type_ecri(3) = 'inst(X)'
-          type_ecri(4) = 'inst(X)'
-          type_ecri(5) = 'inst(X)'
-          type_ecri(6) = 'inst(X)'
-
           ! Attention a reverifier
 
-          ilev=0        
-          DO k=1, nlevSTD
-             bb2=clevSTD(k)
-             IF(bb2.EQ."850".OR.bb2.EQ."700".OR.bb2.EQ."500".OR.bb2.EQ."200" &
+    ilev=0        
+    DO k=1, nlevSTD
+      bb2=clevSTD(k)
+      IF(bb2.EQ."850".OR.bb2.EQ."700".OR.bb2.EQ."500".OR.bb2.EQ."200" &
                   .OR.bb2.EQ."100".OR.bb2.EQ."50".OR.bb2.EQ."10")THEN
-                ilev=ilev+1
-                !     print*,'ilev k bb2 flag name ',ilev,k, bb2,o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name,"Zonal wind "//bb2//"hPa", "m/s")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_vSTDlevs(ilev)%flag,o_vSTDlevs(ilev)%name,"Meridional wind "//bb2//"hPa", "m/s")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_wSTDlevs(ilev)%flag,o_wSTDlevs(ilev)%name,"Vertical wind "//bb2//"hPa", "Pa/s")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_zSTDlevs(ilev)%flag,o_zSTDlevs(ilev)%name,"Geopotential height "//bb2//"hPa", "m")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_qSTDlevs(ilev)%flag,o_qSTDlevs(ilev)%name,"Specific humidity "//bb2//"hPa", "kg/kg" )
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_tSTDlevs(ilev)%flag,o_tSTDlevs(ilev)%name,"Temperature "//bb2//"hPa", "K")
-             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR."500".OR.bb2.EQ."200".OR.bb2.EQ."50".OR.bb2.EQ."10")
-          ENDDO
-          type_ecri(:) = type_ecri_files(:)
-
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_t_oce_sic%flag,o_t_oce_sic%name, "Temp mixte oce-sic", "K")
-
-          IF (type_ocean=='slab') & 
-               CALL histdef2d(iff,clef_stations(iff), &
-               o_slab_bils%flag, o_slab_bils%name,"Bilan au sol sur ocean slab", "W/m2")
-
-          ! Couplage conv-CL
-          IF (iflag_con.GE.3) THEN
-             IF (iflag_coupl>=1) THEN
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_ale_bl%flag,o_ale_bl%name, "ALE BL", "m2/s2") 
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_alp_bl%flag,o_alp_bl%name, "ALP BL", "m2/s2") 
-             ENDIF
-          ENDIF !(iflag_con.GE.3)
-
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_weakinv%flag,o_weakinv%name, "Weak inversion", "-")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_dthmin%flag,o_dthmin%name, "dTheta mini", "K/m")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_rh2m%flag,o_rh2m%name, "Relative humidity at 2m", "%" )
-
-          IF (.NOT.clef_stations(iff)) THEN 
-             !
-             !IM: there is no way to have one single value in a netcdf file
-             !
-             type_ecri(1) = 't_min(X)'
-             type_ecri(2) = 't_min(X)'
-             type_ecri(3) = 't_min(X)'
-             type_ecri(4) = 't_min(X)'
-             type_ecri(5) = 't_min(X)'
-             type_ecri(6) = 't_min(X)'
-             CALL histdef2d(iff,clef_stations(iff),o_rh2m_min%flag,o_rh2m_min%name, "Min Relative humidity at 2m", "%" )
-             type_ecri(1) = 't_max(X)'
-             type_ecri(2) = 't_max(X)'
-             type_ecri(3) = 't_max(X)'
-             type_ecri(4) = 't_max(X)'
-             type_ecri(5) = 't_max(X)'
-             type_ecri(6) = 't_max(X)'
-             CALL histdef2d(iff,clef_stations(iff),o_rh2m_max%flag,o_rh2m_max%name, "Max Relative humidity at 2m", "%" )
-          ENDIF
-
-          type_ecri(:) = type_ecri_files(:)
-          CALL histdef2d(iff,clef_stations(iff),o_qsat2m%flag,o_qsat2m%name, "Saturant humidity at 2m", "%")
-          CALL histdef2d(iff,clef_stations(iff),o_tpot%flag,o_tpot%name, "Surface air potential temperature", "K")
-          CALL histdef2d(iff,clef_stations(iff), &
-               o_tpote%flag,o_tpote%name, "Surface air equivalent potential temperature", "K")
-          CALL histdef2d(iff,clef_stations(iff),o_SWnetOR%flag,o_SWnetOR%name, "Sfce net SW radiation OR", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_SWdownOR%flag,o_SWdownOR%name, "Sfce incident SW radiation OR", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_LWdownOR%flag,o_LWdownOR%name, "Sfce incident LW radiation OR", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_snowl%flag,o_snowl%name, "Solid Large-scale Precip.", "kg/(m2*s)")
-
-          CALL histdef2d(iff,clef_stations(iff),o_solldown%flag,o_solldown%name, "Down. IR rad. at surface", "W/m2")
-          CALL histdef2d(iff,clef_stations(iff),o_dtsvdfo%flag,o_dtsvdfo%name, "Boundary-layer dTs(o)", "K/s")
-          CALL histdef2d(iff,clef_stations(iff),o_dtsvdft%flag,o_dtsvdft%name, "Boundary-layer dTs(t)", "K/s")
-          CALL histdef2d(iff,clef_stations(iff),o_dtsvdfg%flag,o_dtsvdfg%name, "Boundary-layer dTs(g)", "K/s")
-          CALL histdef2d(iff,clef_stations(iff),o_dtsvdfi%flag,o_dtsvdfi%name, "Boundary-layer dTs(g)", "K/s")
-          CALL histdef2d(iff,clef_stations(iff),o_rugs%flag,o_rugs%name, "rugosity", "-" )
+            ilev=ilev+1
+            !     print*,'ilev k bb2 flag name ',ilev,k, bb2,o_uSTDlevs(ilev)%flag,o_uSTDlevs(ilev)%name
+            CALL histdef2d(iff,o_uSTDlevs(ilev))
+            CALL histdef2d(iff,o_vSTDlevs(ilev))
+            CALL histdef2d(iff,o_wSTDlevs(ilev))
+            CALL histdef2d(iff,o_zSTDlevs(ilev))
+            CALL histdef2d(iff,o_qSTDlevs(ilev))
+            CALL histdef2d(iff,o_tSTDlevs(ilev))
+      ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR."500".OR.bb2.EQ."200".OR.bb2.EQ."50".OR.bb2.EQ."10")
+    ENDDO
+
+    CALL histdef2d(iff,o_t_oce_sic)
+
+    IF (type_ocean=='slab') THEN
+      CALL histdef2d(iff,o_slab_bils)
+    ENDIF
+
+    ! Couplage conv-CL
+    IF (iflag_con.GE.3) THEN
+      IF (iflag_coupl>=1) THEN
+            CALL histdef2d(iff,o_ale_bl)
+            CALL histdef2d(iff,o_alp_bl)
+      ENDIF
+    ENDIF !(iflag_con.GE.3)
+
+    CALL histdef2d(iff,o_weakinv)
+    CALL histdef2d(iff,o_dthmin)
+
+    CALL histdef2d(iff,o_rh2m)
+    CALL histdef2d(iff,o_rh2m_min)
+    CALL histdef2d(iff,o_rh2m_max)
+
+    CALL histdef2d(iff,o_qsat2m)
+    CALL histdef2d(iff,o_tpot)
+    CALL histdef2d(iff,o_tpote)
+    CALL histdef2d(iff,o_SWnetOR)
+    CALL histdef2d(iff,o_SWdownOR)
+    CALL histdef2d(iff,o_LWdownOR)
+    CALL histdef2d(iff,o_snowl)
+    CALL histdef2d(iff,o_solldown)
+    CALL histdef2d(iff,o_dtsvdfo)
+    CALL histdef2d(iff,o_dtsvdft)
+    CALL histdef2d(iff,o_dtsvdfg)
+    CALL histdef2d(iff,o_dtsvdfi)
+    CALL histdef2d(iff,o_rugs)
 
           ! Champs 3D:
-          CALL histdef3d(iff,clef_stations(iff),o_ec550aer%flag,o_ec550aer%name, "Extinction at 550nm", "m^-1")
-          CALL histdef3d(iff,clef_stations(iff),o_lwcon%flag,o_lwcon%name, "Cloud liquid water content", "kg/kg")
-          CALL histdef3d(iff,clef_stations(iff),o_iwcon%flag,o_iwcon%name, "Cloud ice water content", "kg/kg")
-          CALL histdef3d(iff,clef_stations(iff),o_temp%flag,o_temp%name, "Air temperature", "K" )
-          CALL histdef3d(iff,clef_stations(iff),o_theta%flag,o_theta%name, "Potential air temperature", "K" )
-          CALL histdef3d(iff,clef_stations(iff),o_ovap%flag,o_ovap%name, "Specific humidity", "kg/kg" )
-          CALL histdef3d(iff,clef_stations(iff),o_oliq%flag,o_oliq%name, "Condensed water", "kg/kg" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_ovapinit%flag,o_ovapinit%name, "Specific humidity (begin of timestep)", "kg/kg" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_geop%flag,o_geop%name, "Geopotential height", "m2/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_vitu%flag,o_vitu%name, "Zonal wind", "m/s" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_vitv%flag,o_vitv%name, "Meridional wind", "m/s" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_vitw%flag,o_vitw%name, "Vertical wind", "Pa/s" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_pres%flag,o_pres%name, "Air pressure", "Pa" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_paprs%flag,o_paprs%name, "Air pressure Inter-Couches", "Pa" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_mass%flag,o_mass%name, "Masse Couches", "kg/m2" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_zfull%flag,o_zfull%name, "Altitude of full pressure levels", "m" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_zhalf%flag,o_zhalf%name, "Altitude of half pressure levels", "m" )
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rneb%flag,o_rneb%name, "Cloud fraction", "-")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rnebcon%flag,o_rnebcon%name, "Convective Cloud Fraction", "-")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rnebls%flag,o_rnebls%name, "LS Cloud fraction", "-")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rhum%flag,o_rhum%name, "Relative humidity", "-")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_ozone%flag,o_ozone%name, "Ozone mole fraction", "-")
-          if (read_climoz == 2) &
-               CALL histdef3d(iff,clef_stations(iff), &
-               o_ozone_light%flag,o_ozone_light%name, &
-               "Daylight ozone mole fraction", "-")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtphy%flag,o_dtphy%name, "Physics dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dqphy%flag,o_dqphy%name, "Physics dQ", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_cldtau%flag,o_cldtau%name, "Cloud optical thickness", "1")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_cldemi%flag,o_cldemi%name, "Cloud optical emissivity", "1")
-          !IM: bug ?? dimensionnement variables (klon,klev+1) pmflxr, pmflxs, prfl, psfl
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_pr_con_l%flag,o_pr_con_l%name, "Convective precipitation lic", " ")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_pr_con_i%flag,o_pr_con_i%name, "Convective precipitation ice", " ")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_pr_lsc_l%flag,o_pr_lsc_l%name, "Large scale precipitation lic", " ")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_pr_lsc_i%flag,o_pr_lsc_i%name, "Large scale precipitation ice", " ")
-          !Cloud droplet effective radius
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_re%flag,o_re%name, "Cloud droplet effective radius","um")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_fl%flag,o_fl%name, "Denominator of Cloud droplet effective radius"," ")
-          !FH Sorties pour la couche limite
-          if (iflag_pbl>1) then
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_tke%flag,o_tke%name, "TKE", "m2/s2")
-             IF (.NOT.clef_stations(iff)) THEN 
-                !
-                !IM: there is no way to have one single value in a netcdf file
-                !
-                type_ecri(1) = 't_max(X)'
-                type_ecri(2) = 't_max(X)'
-                type_ecri(3) = 't_max(X)'
-                type_ecri(4) = 't_max(X)'
-                type_ecri(5) = 't_max(X)'
-                type_ecri(6) = 't_max(X)'
-                CALL histdef3d(iff,clef_stations(iff), &
-                     o_tke_max%flag,o_tke_max%name, "TKE max", "m2/s2")
-             ENDIF
-             type_ecri(:) = type_ecri_files(:)
-          endif
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_kz%flag,o_kz%name, "Kz melange", "m2/s")
-          IF (.NOT.clef_stations(iff)) THEN 
-             !
-             !IM: there is no way to have one single value in a netcdf file
-             !
-             type_ecri(1) = 't_max(X)'
-             type_ecri(2) = 't_max(X)'
-             type_ecri(3) = 't_max(X)'
-             type_ecri(4) = 't_max(X)'
-             type_ecri(5) = 't_max(X)'
-             type_ecri(6) = 't_max(X)'
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_kz_max%flag,o_kz_max%name, "Kz melange max", "m2/s" )
-          ENDIF
-          type_ecri(:) = type_ecri_files(:)
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_clwcon%flag,o_clwcon%name, "Convective Cloud Liquid water content", "kg/kg") 
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtdyn%flag,o_dtdyn%name, "Dynamics dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dqdyn%flag,o_dqdyn%name, "Dynamics dQ", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dudyn%flag,o_dudyn%name, "Dynamics dU", "m/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dvdyn%flag,o_dvdyn%name, "Dynamics dV", "m/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtcon%flag,o_dtcon%name, "Convection dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_ducon%flag,o_ducon%name, "Convection du", "m/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dvcon%flag,o_dvcon%name, "Convection dv", "m/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dqcon%flag,o_dqcon%name, "Convection dQ", "(kg/kg)/s")
-
-          ! Wakes
-          IF(iflag_con.EQ.3) THEN
-             IF (iflag_wake >= 1) THEN
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_ale_wk%flag,o_ale_wk%name, "ALE WK", "m2/s2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_alp_wk%flag,o_alp_wk%name, "ALP WK", "m2/s2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_ale%flag,o_ale%name, "ALE", "m2/s2")
-                CALL histdef2d(iff,clef_stations(iff), &
-                     o_alp%flag,o_alp%name, "ALP", "W/m2")
-                CALL histdef2d(iff,clef_stations(iff),o_cin%flag,o_cin%name, "Convective INhibition", "m2/s2")
-                CALL histdef2d(iff,clef_stations(iff),o_wape%flag,o_WAPE%name, "WAPE", "m2/s2")
-                CALL histdef2d(iff,clef_stations(iff),o_wake_h%flag,o_wake_h%name, "wake_h", "-")
-                CALL histdef2d(iff,clef_stations(iff),o_wake_s%flag,o_wake_s%name, "wake_s", "-")
-                CALL histdef3d(iff,clef_stations(iff),o_dtwak%flag,o_dtwak%name, "Wake dT", "K/s")
-                CALL histdef3d(iff,clef_stations(iff),o_dqwak%flag,o_dqwak%name, "Wake dQ", "(kg/kg)/s")
-                CALL histdef3d(iff,clef_stations(iff),o_wake_deltat%flag,o_wake_deltat%name, "wake_deltat", " ")
-                CALL histdef3d(iff,clef_stations(iff),o_wake_deltaq%flag,o_wake_deltaq%name, "wake_deltaq", " ")
-                CALL histdef3d(iff,clef_stations(iff),o_wake_omg%flag,o_wake_omg%name, "wake_omg", " ")
-             ENDIF
-!!! RomP             CALL histdef3d(iff,clef_stations(iff),o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
-             CALL histdef3d(iff,clef_stations(iff),o_ftd%flag,o_ftd%name, "tend temp due aux descentes precip", "-")
-             CALL histdef3d(iff,clef_stations(iff),o_fqd%flag,o_fqd%name,"tend vap eau due aux descentes precip", "-")
-          ENDIF !(iflag_con.EQ.3)
-
-          IF(iflag_con.GE.3) THEN   !  RomP >>>
-            CALL histdef3d(iff,clef_stations(iff),o_wdtrainA%flag,o_wdtrainA%name, "precipitation from AA", "-")
-            CALL histdef3d(iff,clef_stations(iff),o_wdtrainM%flag,o_wdtrainM%name, "precipitation from mixture", "-")
-            CALL histdef3d(iff,clef_stations(iff),o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
-          ENDIF !(iflag_con.GE.3)   ! <<< RomP
+    CALL histdef3d(iff,o_ec550aer)
+    CALL histdef3d(iff,o_lwcon)
+    CALL histdef3d(iff,o_iwcon)
+    CALL histdef3d(iff,o_temp)
+    CALL histdef3d(iff,o_theta)
+    CALL histdef3d(iff,o_ovap)
+    CALL histdef3d(iff,o_oliq)
+    CALL histdef3d(iff,o_ovapinit)
+    CALL histdef3d(iff,o_geop)
+    CALL histdef3d(iff,o_vitu)
+    CALL histdef3d(iff,o_vitv)
+    CALL histdef3d(iff,o_vitw)
+    CALL histdef3d(iff,o_pres)
+    CALL histdef3d(iff,o_paprs)
+    CALL histdef3d(iff,o_mass)
+    CALL histdef3d(iff,o_zfull)
+    CALL histdef3d(iff,o_zhalf)
+    CALL histdef3d(iff,o_rneb)
+    CALL histdef3d(iff,o_rnebcon)
+    CALL histdef3d(iff,o_rnebls)
+    CALL histdef3d(iff,o_rhum)
+    CALL histdef3d(iff,o_ozone)
+
+    IF (read_climoz == 2) THEN
+      CALL histdef3d(iff,o_ozone_light)
+    END IF
+
+    CALL histdef3d(iff,o_dtphy)
+    CALL histdef3d(iff,o_dqphy)
+    CALL histdef3d(iff,o_cldtau)
+    CALL histdef3d(iff,o_cldemi)
+!IM: bug ?? dimensionnement variables (klon,klev+1) pmflxr, pmflxs, prfl, psfl
+    CALL histdef3d(iff,o_pr_con_l)
+    CALL histdef3d(iff,o_pr_con_i)
+    CALL histdef3d(iff,o_pr_lsc_l)
+    CALL histdef3d(iff,o_pr_lsc_i)
+!Cloud droplet effective radius
+    CALL histdef3d(iff,o_re)
+    CALL histdef3d(iff,o_fl)
+!FH Sorties pour la couche limite
+    IF (iflag_pbl>1) THEN
+      CALL histdef3d(iff,o_tke)
+      CALL histdef3d(iff,o_tke_max)
+    ENDIF
+    CALL histdef3d(iff,o_kz)
+    CALL histdef3d(iff,o_kz_max)
+    CALL histdef3d(iff,o_clwcon)
+    CALL histdef3d(iff,o_dtdyn)
+    CALL histdef3d(iff,o_dqdyn)
+    CALL histdef3d(iff,o_dudyn)
+    CALL histdef3d(iff,o_dvdyn)
+    CALL histdef3d(iff,o_dtcon)
+    CALL histdef3d(iff,o_ducon)
+    CALL histdef3d(iff,o_dvcon)
+    CALL histdef3d(iff,o_dqcon)
+
+! Wakes
+    IF(iflag_con.EQ.3) THEN
+      IF (iflag_wake >= 1) THEN
+            CALL histdef2d(iff,o_ale_wk)
+            CALL histdef2d(iff,o_alp_wk)
+            CALL histdef2d(iff,o_ale)
+            CALL histdef2d(iff,o_alp)
+            CALL histdef2d(iff,o_cin)
+            CALL histdef2d(iff,o_wape)
+            CALL histdef2d(iff,o_wake_h)
+            CALL histdef2d(iff,o_wake_s)
+            CALL histdef3d(iff,o_dtwak)
+            CALL histdef3d(iff,o_dqwak)
+            CALL histdef3d(iff,o_wake_deltat)
+            CALL histdef3d(iff,o_wake_deltaq)
+            CALL histdef3d(iff,o_wake_omg)
+      ENDIF
+!!! RomP             CALL histdef3d(iff,o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
+      CALL histdef3d(iff,o_ftd)
+      CALL histdef3d(iff,o_fqd)
+    ENDIF !(iflag_con.EQ.3)
+
+    IF(iflag_con.GE.3) THEN   !  RomP >>>
+      CALL histdef3d(iff,o_wdtrainA)
+      CALL histdef3d(iff,o_wdtrainM)
+      CALL histdef3d(iff,o_Vprecip)
+    ENDIF !(iflag_con.GE.3)   ! <<< RomP
 
 !!! nrlmd le 10/04/2012
 
-        IF (iflag_trig_bl>=1) THEN
- CALL histdef2d(iff,clef_stations(iff),o_n2%flag,o_n2%name, "Nombre de panaches de type 2", " ")
- CALL histdef2d(iff,clef_stations(iff),o_s2%flag,o_s2%name, "Surface moyenne des panaches de type 2", "m2")
-
- CALL histdef2d(iff,clef_stations(iff),o_proba_notrig%flag,o_proba_notrig%name, "Probabilité de non-déclenchement", " ")
- CALL histdef2d(iff,clef_stations(iff),o_random_notrig%flag,o_random_notrig%name, "Tirage aléatoire de non-déclenchement", " ")
- CALL histdef2d(iff,clef_stations(iff),o_ale_bl_trig%flag,o_ale_bl_trig%name, "ALE_BL_STAT + Condition P>Pseuil", "m2/s2")
- CALL histdef2d(iff,clef_stations(iff),o_ale_bl_stat%flag,o_ale_bl_stat%name, "ALE_BL_STAT", "m2/s2")
-       ENDIF  !(iflag_trig_bl>=1)
-
-        IF (iflag_clos_bl>=1) THEN
- CALL histdef2d(iff,clef_stations(iff),o_alp_bl_det%flag,o_alp_bl_det%name, "ALP_BL_DET", "W/m2")
- CALL histdef2d(iff,clef_stations(iff),o_alp_bl_fluct_m%flag,o_alp_bl_fluct_m%name, "ALP_BL_FLUCT_M", "W/m2")
- CALL histdef2d(iff,clef_stations(iff),o_alp_bl_fluct_tke%flag,o_alp_bl_fluct_tke%name, "ALP_BL_FLUCT_TKE", "W/m2")
- CALL histdef2d(iff,clef_stations(iff),o_alp_bl_conv%flag,o_alp_bl_conv%name, "ALP_BL_CONV", "W/m2")
- CALL histdef2d(iff,clef_stations(iff),o_alp_bl_stat%flag,o_alp_bl_stat%name, "ALP_BL_STAT", "W/m2")
-       ENDIF  !(iflag_clos_bl>=1)
+    IF (iflag_trig_bl>=1) THEN
+      CALL histdef2d(iff,o_n2)
+      CALL histdef2d(iff,o_s2)
+      CALL histdef2d(iff,o_proba_notrig)
+      CALL histdef2d(iff,o_random_notrig)
+      CALL histdef2d(iff,o_ale_bl_trig)
+      CALL histdef2d(iff,o_ale_bl_stat)
+    ENDIF  !(iflag_trig_bl>=1)
+
+    IF (iflag_clos_bl>=1) THEN
+      CALL histdef2d(iff,o_alp_bl_det)
+      CALL histdef2d(iff,o_alp_bl_fluct_m)
+      CALL histdef2d(iff,o_alp_bl_fluct_tke)
+      CALL histdef2d(iff,o_alp_bl_conv)
+      CALL histdef2d(iff,o_alp_bl_stat)
+    ENDIF  !(iflag_clos_bl>=1)
 
 !!! fin nrlmd le 10/04/2012
-
-          CALL histdef3d(iff,clef_stations(iff),o_dtlsc%flag,o_dtlsc%name, "Condensation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff),o_dtlschr%flag,o_dtlschr%name,"Large-scale condensational heating rate","K/s")
-          CALL histdef3d(iff,clef_stations(iff),o_dqlsc%flag,o_dqlsc%name, "Condensation dQ", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff),o_beta_prec%flag,o_beta_prec%name, "LS Conversion rate to prec", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff),o_dtvdf%flag,o_dtvdf%name, "Boundary-layer dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff),o_dqvdf%flag,o_dqvdf%name, "Boundary-layer dQ", "(kg/kg)/s") 
-          CALL histdef3d(iff,clef_stations(iff),o_dteva%flag,o_dteva%name, "Reevaporation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff),o_dqeva%flag,o_dqeva%name, "Reevaporation dQ", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff),o_ptconv%flag,o_ptconv%name, "POINTS CONVECTIFS", " ")
-          CALL histdef3d(iff,clef_stations(iff),o_ratqs%flag,o_ratqs%name, "RATQS", " ")
-          CALL histdef3d(iff,clef_stations(iff),o_dtthe%flag,o_dtthe%name, "Thermal dT", "K/s")
-
-          if(iflag_thermals.ge.1) THEN
-             CALL histdef3d(iff,clef_stations(iff),o_dqlscth%flag,o_dqlscth%name, "dQ therm.", "(kg/kg)/s")
-             CALL histdef3d(iff,clef_stations(iff),o_dqlscst%flag,o_dqlscst%name, "dQ strat.", "(kg/kg)/s")
-             CALL histdef3d(iff,clef_stations(iff),o_dtlscth%flag,o_dtlscth%name, "dQ therm.", "K/s")
-             CALL histdef3d(iff,clef_stations(iff),o_dtlscst%flag,o_dtlscst%name, "dQ strat.", "K/s")
-             CALL histdef2d(iff,clef_stations(iff),o_plulth%flag,o_plulth%name, "Rainfall therm.", "K/s")
-             CALL histdef2d(iff,clef_stations(iff),o_plulst%flag,o_plulst%name, "Rainfall strat.", "K/s")
-             CALL histdef2d(iff,clef_stations(iff),o_lmaxth%flag,o_lmaxth%name, "Upper level thermals", "")
-             CALL histdef3d(iff,clef_stations(iff),o_ptconvth%flag,o_ptconvth%name, "POINTS CONVECTIFS therm.", " ")
-             CALL histdef3d(iff,clef_stations(iff),o_f_th%flag,o_f_th%name, "Thermal plume mass flux", "kg/(m2*s)")
-             CALL histdef3d(iff,clef_stations(iff),o_e_th%flag,o_e_th%name,"Thermal plume entrainment","K/s")
-             CALL histdef3d(iff,clef_stations(iff),o_w_th%flag,o_w_th%name,"Thermal plume vertical velocity","m/s")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_ftime_th%flag,o_ftime_th%name,"Fraction of time Shallow convection occurs"," ")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_q_th%flag,o_q_th%name, "Thermal plume total humidity", "kg/kg")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_a_th%flag,o_a_th%name, "Thermal plume fraction", "")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_d_th%flag,o_d_th%name, "Thermal plume detrainment", "K/s")
-
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_f0_th%flag,o_f0_th%name, "Thermal closure mass flux", "K/s")
-             CALL histdef2d(iff,clef_stations(iff), &
-                  o_zmax_th%flag,o_zmax_th%name, "Thermal plume height", "K/s")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dqthe%flag,o_dqthe%name, "Thermal dQ", "(kg/kg)/s")
-          endif !iflag_thermals.ge.1
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtajs%flag,o_dtajs%name, "Dry adjust. dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dqajs%flag,o_dqajs%name, "Dry adjust. dQ", "(kg/kg)/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtswr%flag,o_dtswr%name, "SW radiation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtsw0%flag,o_dtsw0%name, "CS SW radiation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtlwr%flag,o_dtlwr%name, "LW radiation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtlw0%flag,o_dtlw0%name, "CS LW radiation dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dtec%flag,o_dtec%name, "Cinetic dissip dT", "K/s")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_duvdf%flag,o_duvdf%name, "Boundary-layer dU", "m/s2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dvvdf%flag,o_dvvdf%name, "Boundary-layer dV", "m/s2")
-
-          IF (ok_orodr) THEN
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_duoro%flag,o_duoro%name, "Orography dU", "m/s2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dvoro%flag,o_dvoro%name, "Orography dV", "m/s2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dtoro%flag,o_dtoro%name, "Orography dT", "K/s")
-          ENDIF
-
-          IF (ok_orolf) THEN
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dulif%flag,o_dulif%name, "Orography dU", "m/s2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dvlif%flag,o_dvlif%name, "Orography dV", "m/s2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dtlif%flag,o_dtlif%name, "Orography dT", "K/s")
-          ENDIF
-
-          IF (ok_hines) then
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_duhin%flag,o_duhin%name, "Hines GWD dU", "m/s2")
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dvhin%flag,o_dvhin%name, "Hines GWD dV", "m/s2")
-
-             CALL histdef3d(iff,clef_stations(iff), &
-                  o_dthin%flag,o_dthin%name, "Hines GWD dT", "K/s")
-          ENDIF
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rsu%flag,o_rsu%name, "SW upward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rsd%flag,o_rsd%name, "SW downward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rlu%flag,o_rlu%name, "LW upward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rld%flag,o_rld%name, "LW downward radiation", "W m-2")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rsucs%flag,o_rsucs%name, "SW CS upward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rsdcs%flag,o_rsdcs%name, "SW CS downward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rlucs%flag,o_rlucs%name, "LW CS upward radiation", "W m-2")
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_rldcs%flag,o_rldcs%name, "LW CS downward radiation", "W m-2")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tnt%flag,o_tnt%name, "Tendency of air temperature", "K s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tntc%flag,o_tntc%name, "Tendency of air temperature due to Moist Convection", &
-               "K s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tntr%flag,o_tntr%name, "Air temperature tendency due to Radiative heating", &
-               "K s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tntscpbl%flag,o_tntscpbl%name, "Air temperature tendency due to St cloud and precipitation and BL mixing", &
-               "K s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tnhus%flag,o_tnhus%name, "Tendency of specific humidity", "s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tnhusc%flag,o_tnhusc%name, "Tendency of specific humidity due to convection", "s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_tnhusscpbl%flag,o_tnhusscpbl%name, "Tendency of Specific humidity due to ST cl, precip and BL mixing", &
-               "s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_evu%flag,o_evu%name, "Eddy viscosity coefficient for Momentum Variables", "m2 s-1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_h2o%flag,o_h2o%name, "Mass Fraction of Water", "1")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_mcd%flag,o_mcd%name, "Downdraft COnvective Mass Flux", "kg/(m2*s)")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_dmc%flag,o_dmc%name, "Deep COnvective Mass Flux", "kg/(m2*s)")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_ref_liq%flag,o_ref_liq%name, "Effective radius of convective cloud liquid water particle", "m")
-
-          CALL histdef3d(iff,clef_stations(iff), &
-               o_ref_ice%flag,o_ref_ice%name, "Effective radius of startiform cloud ice particle", "m")
-
-          if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR. &
+    CALL histdef3d(iff,o_dtlsc)
+    CALL histdef3d(iff,o_dtlschr)
+    CALL histdef3d(iff,o_dqlsc)
+    CALL histdef3d(iff,o_beta_prec)
+    CALL histdef3d(iff,o_dtvdf)
+    CALL histdef3d(iff,o_dtdis)
+    CALL histdef3d(iff,o_dqvdf)
+    CALL histdef3d(iff,o_dteva)
+    CALL histdef3d(iff,o_dqeva)
+    CALL histdef3d(iff,o_ptconv)
+    CALL histdef3d(iff,o_ratqs)
+    CALL histdef3d(iff,o_dtthe)
+
+    IF (iflag_thermals.ge.1) THEN
+      CALL histdef3d(iff,o_dqlscth)
+      CALL histdef3d(iff,o_dqlscst)
+      CALL histdef3d(iff,o_dtlscth)
+      CALL histdef3d(iff,o_dtlscst)
+      CALL histdef2d(iff,o_plulth)
+      CALL histdef2d(iff,o_plulst)
+      CALL histdef2d(iff,o_lmaxth)
+      CALL histdef3d(iff,o_ptconvth)
+      CALL histdef3d(iff,o_f_th)
+      CALL histdef3d(iff,o_e_th)
+      CALL histdef3d(iff,o_w_th)
+      CALL histdef3d(iff,o_lambda_th)
+      CALL histdef2d(iff,o_ftime_th)
+      CALL histdef3d(iff,o_q_th)
+      CALL histdef3d(iff,o_a_th)
+      CALL histdef3d(iff,o_d_th)
+      CALL histdef2d(iff,o_f0_th)
+      CALL histdef2d(iff,o_zmax_th)
+      CALL histdef3d(iff,o_dqthe)
+    ENDIF !iflag_thermals.ge.1
+
+    CALL histdef3d(iff,o_dtajs)
+    CALL histdef3d(iff,o_dqajs)
+    CALL histdef3d(iff,o_dtswr)
+    CALL histdef3d(iff,o_dtsw0)
+    CALL histdef3d(iff,o_dtlwr)
+    CALL histdef3d(iff,o_dtlw0)
+    CALL histdef3d(iff,o_dtec)
+    CALL histdef3d(iff,o_duvdf)
+    CALL histdef3d(iff,o_dvvdf)
+
+    IF (ok_orodr) THEN
+      CALL histdef3d(iff,o_duoro)
+      CALL histdef3d(iff,o_dvoro)
+      CALL histdef3d(iff,o_dtoro)
+    ENDIF
+
+    IF (ok_orolf) THEN
+      CALL histdef3d(iff,o_dulif)
+      CALL histdef3d(iff,o_dvlif)
+      CALL histdef3d(iff,o_dtlif)
+    ENDIF
+
+    IF (ok_hines) then
+      CALL histdef3d(iff,o_duhin)
+      CALL histdef3d(iff,o_dvhin)
+      CALL histdef3d(iff,o_dthin)
+    ENDIF
+
+    CALL histdef3d(iff,o_rsu)
+    CALL histdef3d(iff,o_rsd)
+    CALL histdef3d(iff,o_rlu)
+    CALL histdef3d(iff,o_rld)
+    CALL histdef3d(iff,o_rsucs)
+    CALL histdef3d(iff,o_rsdcs)
+    CALL histdef3d(iff,o_rlucs)
+    CALL histdef3d(iff,o_rldcs)
+    CALL histdef3d(iff,o_tnt)
+    CALL histdef3d(iff,o_tntc)
+    CALL histdef3d(iff,o_tntr)
+    CALL histdef3d(iff,o_tntscpbl)
+    CALL histdef3d(iff,o_tnhus)
+    CALL histdef3d(iff,o_tnhusc)
+    CALL histdef3d(iff,o_tnhusscpbl)
+    CALL histdef3d(iff,o_evu)
+    CALL histdef3d(iff,o_h2o)
+    CALL histdef3d(iff,o_mcd)
+    CALL histdef3d(iff,o_dmc)
+    CALL histdef3d(iff,o_ref_liq)
+    CALL histdef3d(iff,o_ref_ice)
+
+    IF (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR. &
                RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR. &
                RCFC12_per.NE.RCFC12_act) THEN
-
-             CALL histdef2d(iff,clef_stations(iff),o_rsut4co2%flag,o_rsut4co2%name, &
-                  "TOA Out SW in 4xCO2 atmosphere", "W/m2") 
-             CALL histdef2d(iff,clef_stations(iff),o_rlut4co2%flag,o_rlut4co2%name, &
-                  "TOA Out LW in 4xCO2 atmosphere", "W/m2") 
-             CALL histdef2d(iff,clef_stations(iff),o_rsutcs4co2%flag,o_rsutcs4co2%name, &
-                  "TOA Out CS SW in 4xCO2 atmosphere", "W/m2") 
-             CALL histdef2d(iff,clef_stations(iff),o_rlutcs4co2%flag,o_rlutcs4co2%name, &
-                  "TOA Out CS LW in 4xCO2 atmosphere", "W/m2") 
-
-             CALL histdef3d(iff,clef_stations(iff),o_rsu4co2%flag,o_rsu4co2%name, &
-                  "Upwelling SW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rlu4co2%flag,o_rlu4co2%name, &
-                  "Upwelling LW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rsucs4co2%flag,o_rsucs4co2%name, &
-                  "Upwelling CS SW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rlucs4co2%flag,o_rlucs4co2%name, &
-                  "Upwelling CS LW 4xCO2 atmosphere", "W/m2") 
-
-             CALL histdef3d(iff,clef_stations(iff),o_rsd4co2%flag,o_rsd4co2%name, &
-                  "Downwelling SW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rld4co2%flag,o_rld4co2%name, &
-                  "Downwelling LW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rsdcs4co2%flag,o_rsdcs4co2%name, &
-                  "Downwelling CS SW 4xCO2 atmosphere", "W/m2") 
-             CALL histdef3d(iff,clef_stations(iff),o_rldcs4co2%flag,o_rldcs4co2%name, &
-                  "Downwelling CS LW 4xCO2 atmosphere", "W/m2") 
-
-          endif
-
-
-          IF (nqtot>=3) THEN
-             DO iq=3,nqtot  
-                iiq=niadv(iq)
-                o_trac(iq-2) = ctrl_out((/ 4, 5, 1, 1, 1, 10 /),tname(iiq))
-                CALL histdef3d (iff,clef_stations(iff), &
-                o_trac(iq-2)%flag,o_trac(iq-2)%name,'Tracer '//ttext(iiq), "-" )
-                o_trac_cum(iq-2) = ctrl_out((/ 3, 4, 10, 10, 10, 10 /),'cum'//tname(iiq))
-                CALL histdef2d (iff,clef_stations(iff), &
-                o_trac_cum(iq-2)%flag,o_trac_cum(iq-2)%name,'Cumulated tracer '//ttext(iiq), "-" )
-             ENDDO
-          ENDIF
-
-          CALL histend(nid_files(iff))
-
-          ndex2d = 0
-          ndex3d = 0
-
-       ENDIF ! clef_files
+      CALL histdef2d(iff,o_rsut4co2)
+      CALL histdef2d(iff,o_rlut4co2)
+      CALL histdef2d(iff,o_rsutcs4co2)
+      CALL histdef2d(iff,o_rlutcs4co2)
+      CALL histdef3d(iff,o_rsu4co2)
+      CALL histdef3d(iff,o_rlu4co2)
+      CALL histdef3d(iff,o_rsucs4co2)
+      CALL histdef3d(iff,o_rlucs4co2)
+      CALL histdef3d(iff,o_rsd4co2)
+      CALL histdef3d(iff,o_rld4co2)
+      CALL histdef3d(iff,o_rsdcs4co2)
+      CALL histdef3d(iff,o_rldcs4co2)
+
+    ENDIF
+
+
+      IF (nqtot>=3) THEN
+            DO iq=3,nqtot  
+            iiq=niadv(iq)
+            o_trac(iq-2) = ctrl_out((/ 4, 5, 1, 1, 1, 10 /),tname(iiq),'Tracer '//ttext(iiq), "-",&
+                  (/ '', '', '', '', '', '' /))
+            CALL histdef3d(iff, o_trac(iq-2))
+            o_trac_cum(iq-2) = ctrl_out((/ 3, 4, 10, 10, 10, 10 /),'cum'//tname(iiq),&
+                  'Cumulated tracer '//ttext(iiq), "-", (/ '', '', '', '', '', '' /))
+            CALL histdef2d(iff, o_trac_cum(iq-2))
+            ENDDO
+      ENDIF
+
+      CALL histend(nid_files(iff))
+
+      ndex2d = 0
+      ndex3d = 0
+
+    ENDIF ! clef_files
 
     ENDDO !  iff
